<?php

// register and enqueue CSS styles
function theme_styles_scripts () {
	
	wp_register_style('theme',get_stylesheet_directory_uri().'/style.css', array(), false, 'all');
	wp_register_style('lessframework',get_template_directory_uri().'/lessframework.css', array(), false, 'all');
	wp_register_style('orbit',get_template_directory_uri().'/includes/orbit-slider/orbit-1.2.3.css', array(), false, 'all');
	wp_register_style('expslider',get_template_directory_uri().'/scripts/expanding-slider/css/es-style.css', array(), false, 'all');
	wp_register_style('expsliderscroll',get_template_directory_uri().'/scripts/expanding-slider/css/jquery.jscrollpane.css', array(), false, 'all');
	
	wp_enqueue_style('lessframework');
	wp_enqueue_style('theme');
	wp_enqueue_style('orbit');
	wp_enqueue_style('expslider');
	wp_enqueue_style('expsliderscroll');
	
	wp_register_script('overlay', get_template_directory_uri() . '/scripts/filterable-portfolio/overlay.js', array('jquery'), false, true);
	wp_register_script('search', get_template_directory_uri() . '/scripts/search/search.js', array('jquery'), false, true);
	wp_register_script('orbitslider', get_template_directory_uri() . '/includes/orbit-slider/jquery.orbit-1.2.3.js', array('jquery'), '1.2.3', true);
	wp_register_script('expcarousel', get_template_directory_uri() . '/scripts/expanding-slider/js/jquery.contentcarousel.js', array('jquery'), false, true);

	wp_enqueue_script('overlay');
	wp_enqueue_script('search');
	wp_enqueue_script('orbitslider');
	wp_enqueue_script('expcarousel');

}
add_action('wp_enqueue_scripts', 'theme_styles_scripts');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Set the content width
if ( ! isset( $content_width ) )
    $content_width = 656;
 
function theme_adjust_content_width() {
    global $content_width;
 
    if ( is_page_template( 'page_full-width.php' ) || is_page_template('page_portfolio-one-column.php') || is_page_template('page_portfolio-two-column.php') || is_page_template('page_portfolio-three-column.php') || is_page_template('page_portfolio-four-column.php') || is_page_template('single-project.php') || is_page_template('front-page.php') || is_page_template('404.php') )
    	$content_width = 914;
}
add_action( 'template_redirect', 'theme_adjust_content_width' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// enables widgetized sidebars
if ( function_exists('register_sidebar') )
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Sidebar Widgets
// Location: the sidebar
register_sidebar(array('name'=>'Sidebar',
	'id' => 'sidebar-1',
	'before_widget' => '<div class="widget-area widget-sidebar %2$s">',
	'after_widget' => '<div class="clearleft"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Footer Widgets
// Location: at the top of the footer, above the copyright
register_sidebar(array('name'=>'Footer',
	'id' => 'sidebar-2',
	'before_widget' => '<div class="widget-area widget-footer %2$s">',
	'after_widget' => '</div>',
	'before_title' => '<h4>',
	'after_title' => '</h4>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Front Page Widgets Above Content
// Location: front page, above the content area
register_sidebar(array('name'=>'Front Page Above Content',
	'id' => 'sidebar-3',
	'before_widget' => '<div class="widget-area widget-sidebar widget-front-top %2$s">',
	'after_widget' => '<div class="clearleft"></div></div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Front Page Widgets Below Content
// Location: front page, below the content area
register_sidebar(array('name'=>'Front Page Below Content',
	'id' => 'sidebar-4',
	'before_widget' => '<div class="widget-area widget-sidebar widget-front-bottom %2$s">',
	'after_widget' => '</div>',
	'before_title' => '<h3>',
	'after_title' => '</h3><div class="clearleft"></div>',
));
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Activate included plugins on theme activation
require_once dirname( __FILE__ ) . '/includes/class-tgm-plugin-activation.php';
add_action( 'tgmpa_register', 'my_theme_register_required_plugins' );
function my_theme_register_required_plugins() {
    $plugins = array( 
        array(
            'name'                  => 'Advanced Recent Posts', 
            'slug'                  => 'advanced-recent-posts', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-recent-posts.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Contact Form', 
            'slug'                  => 'contact-form', 
            'source'                => get_template_directory() . '/includes/plugins/contact-form.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Quick Localization', 
            'slug'                  => 'quick-localization', 
            'source'                => get_template_directory() . '/includes/plugins/quick-localization.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Advanced SEO', 
            'slug'                  => 'advanced-seo', 
            'source'                => get_template_directory() . '/includes/plugins/advanced-seo.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),
		array(
            'name'                  => 'Shortcodes', 
            'slug'                  => 'shortcodes', 
            'source'                => get_template_directory() . '/includes/plugins/shortcodes.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),array(
            'name'                  => 'Social media Widget', 
            'slug'                  => 'social-media-widget', 
            'source'                => get_template_directory() . '/includes/plugins/social-media-widget.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        ),array(
            'name'                  => 'Twitter Widget', 
            'slug'                  => 'twitter-widget', 
            'source'                => get_template_directory() . '/includes/plugins/twitter-widget.zip', 
            'required'              => false, 
            'force_activation'      => true, 
            'force_deactivation'    => true, 
        )
    );
  
    $config = array(
        'domain'            => 'satori',           
        'default_path'      => '',                          
        'parent_menu_slug'  => 'themes.php',         
        'parent_url_slug'   => 'themes.php',        
        'menu'              => 'install-required-plugins',   
        'has_notices'       => true,                        
        'is_automatic'      => true,            
        'message'           => '',               
        'strings'           => array(
            'page_title'                                => __( 'Install Required Plugins', 'satori' ),
            'menu_title'                                => __( 'Install Required Plugins', 'satori' ),
            'installing'                                => __( 'Installing Plugin: %s', 'satori' ), // %1$s = plugin name
            'oops'                                      => __( 'Something went wrong with the plugin API.', 'satori' ),
            'notice_can_install_required'               => _n_noop( 'This theme requires the following plugin: %1$s.', 'This theme requires the following plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_install_recommended'            => _n_noop( 'This theme recommends the following plugin: %1$s.', 'This theme recommends installing the following pre-packaged plugins: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_install'                     => _n_noop( 'Sorry, but you do not have the correct permissions to install the %s plugin. Contact the administrator of this site for help on getting the plugin installed.', 'Sorry, but you do not have the correct permissions to install the %s plugins. Contact the administrator of this site for help on getting the plugins installed.' ), // %1$s = plugin name(s)
            'notice_can_activate_required'              => _n_noop( 'The following required plugin is currently inactive: %1$s.', 'The following required plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_can_activate_recommended'           => _n_noop( 'The following recommended plugin is currently inactive: %1$s.', 'The following recommended plugins are currently inactive: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_activate'                    => _n_noop( 'Sorry, but you do not have the correct permissions to activate the %s plugin. Contact the administrator of this site for help on getting the plugin activated.', 'Sorry, but you do not have the correct permissions to activate the %s plugins. Contact the administrator of this site for help on getting the plugins activated.' ), // %1$s = plugin name(s)
            'notice_ask_to_update'                      => _n_noop( 'The following plugin needs to be updated to its latest version to ensure maximum compatibility with this theme: %1$s.', 'The following plugins need to be updated to their latest version to ensure maximum compatibility with this theme: %1$s.' ), // %1$s = plugin name(s)
            'notice_cannot_update'                      => _n_noop( 'Sorry, but you do not have the correct permissions to update the %s plugin. Contact the administrator of this site for help on getting the plugin updated.', 'Sorry, but you do not have the correct permissions to update the %s plugins. Contact the administrator of this site for help on getting the plugins updated.' ), // %1$s = plugin name(s)
            'install_link'                              => _n_noop( 'Begin installing plugin', 'Begin installing plugins' ),
            'activate_link'                             => _n_noop( 'Activate installed plugin', 'Activate installed plugins' ),
            'return'                                    => __( 'Return to Required Plugins Installer', 'satori' ),
            'plugin_activated'                          => __( 'Plugin activated successfully.', 'satori' ),
            'complete'                                  => __( 'All plugins installed and activated successfully. %s', 'satori' ) // %1$s = dashboard link
        )
    );
 
    tgmpa( $plugins, $config );
 
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Post thumbnail support
add_theme_support( 'post-thumbnails' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Add RSS links
add_theme_support( 'automatic-feed-links' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Adds the post thumbnail to the RSS feed
function get_the_content_with_formatting ($more_link_text = '(more...)', $stripteaser = 0, $more_file = '') {
	$content = get_the_content($more_link_text, $stripteaser, $more_file);
	$content = apply_filters('the_content', $content);
	$content = str_replace(']]>', ']]&gt;', $content);
	return $content;
}

function cwc_rss_post_thumbnail($content) {
	global $post;
	if(has_post_thumbnail($post->ID)) {
		$content = '<p>' . get_the_post_thumbnail($post->ID) .
		'</p>' . get_the_content_with_formatting();
	}
	return $content;
}
add_filter('the_excerpt_rss', 'cwc_rss_post_thumbnail');
add_filter('the_content_feed', 'cwc_rss_post_thumbnail');

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom menu support
add_theme_support( 'menus' );
if ( function_exists( 'register_nav_menus' ) ) {
	register_nav_menus(
		array(
		  'header-menu' => 'Main Menu',
		)
	);
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Removes Trackbacks from the comment count
add_filter('get_comments_number', 'comment_count', 0);
function comment_count( $count ) {
	if ( ! is_admin() ) {
		global $id;
		$comments_by_type = &separate_comments(get_comments('status=approve&post_id=' . $id));
		return count($comments_by_type['comment']);
	} else {
		return $count;
	}
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// This is needed for the system to create proper versions of uploaded photos and embedded videos
if ( ! isset( $content_width ) ) $content_width = 950;
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// invite rss subscribers to comment
function rss_comment_footer($content) {
	if (is_feed()) {
		if (comments_open()) {
			$content .= 'Comments are open! <a href="'.get_permalink().'">Add yours!</a>';
		}
	}
	return $content;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// custom excerpt ellipses for 2.9+
function custom_excerpt_more($more) {
	return 'Read More &raquo;';
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

add_filter('excerpt_more', 'custom_excerpt_more');
// no more jumping for read more link
function no_more_jumping($post) {
	if(isset($post->ID)) { return '<a href="'.get_permalink($post->ID).'" class="read-more">'.'&nbsp; Continue Reading &raquo;'.'</a>'; }
}
add_filter('excerpt_more', 'no_more_jumping');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// category id in body and post class
function category_id_class($classes) {
	if(is_page || is_post) {
	global $post;
	foreach((get_the_category($post->ID)) as $category)
		$classes [] = 'cat-' . $category->cat_ID . '-id';
		return $classes;
}
add_filter('post_class', 'category_id_class');
add_filter('body_class', 'category_id_class'); }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// adds a class to the post if there is a thumbnail
function has_thumb_class($classes) {
	global $post;
	if( has_post_thumbnail($post->ID) ) { $classes[] = 'has_thumb'; }
		return $classes;
}
add_filter('post_class', 'has_thumb_class');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Make theme available for translation
// Translations can be filed in the /languages/ directory
load_theme_textdomain('satori', get_template_directory() . '/languages');

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// enable threaded comments
function enable_threaded_comments(){
if (!is_admin()) {
	if (is_singular() AND comments_open() AND (get_option('thread_comments') == 1))
		wp_enqueue_script('comment-reply');
	}
}
add_action('get_header', 'enable_threaded_comments');
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add fancybox support
include_once( get_template_directory(). '/includes/easy-fancybox/easy-fancybox.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add a pager
require_once( get_template_directory(). '/includes/pager/pager.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// add dropdown menus for mobile screens
include_once( get_template_directory(). '/includes/dropdown-menus/dropdown-menus.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Recent Posts Slider 
include_once( get_template_directory(). '/includes/recent-posts-slider/recent-posts-slider.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Option Tree integration
include_once( get_template_directory(). '/includes/option-tree/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Custom sidebars
include_once( get_template_directory(). '/includes/custom-sidebars/customsidebars.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

// Full-screen background and slider
include_once( get_template_directory(). '/includes/supersized/index.php' );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Custom Tag Cloud 
add_filter('widget_tag_cloud_args','set_largest_tags');
function set_largest_tags($args) {
$args = array('largest'    => 8);
return $args; }
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Create filterable portfolio 
add_action('init', 'project_custom_init');      

function project_custom_init()  
{  
// The following is all the names, in our tutorial, we use "Project"
$labels = array(
	'name' => _x('Projects', 'post type general name', 'satori'),
	'singular_name' => _x('Project', 'post type singular name', 'satori'),
	'add_new' => _x('Add New', 'project', 'satori'),
	'add_new_item' => __('Add New Project', 'satori'),
	'edit_item' => __('Edit Project', 'satori'),
	'new_item' => __('New Project', 'satori'),
	'view_item' => __('View Project', 'satori'),
	'search_items' => __('Search Projects', 'satori'),
	'not_found' =>  __('No projects found', 'satori'),
	'not_found_in_trash' => __('No projects found in Trash', 'satori'),
	'parent_item_colon' => '',
	'menu_name' => __('Portfolio', 'satori')
);

// Some arguments and in the last line 'supports', we say to WordPress what features are supported on the Project post type
$args = array(
	'labels' => $labels,
	'public' => true,
	'publicly_queryable' => true,
	'show_ui' => true,
	'show_in_menu' => true,
	'query_var' => true,
	'rewrite' => array( 'slug' => 'portfolio' ),
	'capability_type' => 'post',
	'has_archive' => true,
	'hierarchical' => false,
	'menu_position' => null,
	'supports' => array('title','editor','author','thumbnail','excerpt','comments')
);

// We call this function to register the custom post type
register_post_type('project',$args);

// Initialize Taxonomy Labels
$labels = array(
	'name' => _x( 'Tags', 'taxonomy general name' , 'satori'),
	'singular_name' => _x( 'Tag', 'taxonomy singular name', 'satori' ),
	'search_items' =>  __( 'Search Types' , 'satori'),
	'all_items' => __( 'All Tags', 'satori' ),
	'parent_item' => __( 'Parent Tag', 'satori' ),
	'parent_item_colon' => __( 'Parent Tag:', 'satori' ),
	'edit_item' => __( 'Edit Tags', 'satori' ),
	'update_item' => __( 'Update Tag', 'satori' ),
	'add_new_item' => __( 'Add New Tag', 'satori' ),
	'new_item_name' => __( 'New Tag Name', 'satori' ),
);

// Register Custom Taxonomy
register_taxonomy('tagportfolio',array('project'), array(
	'hierarchical' => true, // define whether to use a system like tags or categories
	'labels' => $labels,
	'show_ui' => true,
	'query_var' => true,
	'rewrite' => array( 'slug' => 'tag-portfolio' ),
));


}  

add_filter('post_updated_messages', 'project_updated_messages');

function project_updated_messages( $messages ) {
  global $post, $post_ID;

  $messages['project'] = array(
	0 => '', // Unused. Messages start at index 1.
	1 => sprintf( __('Project updated. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	2 => __('Custom field updated.', 'satori'),
	3 => __('Custom field deleted.', 'satori'),
	4 => __('Project updated.', 'satori'),
	/* translators: %s: date and time of the revision */
	5 => isset($_GET['revision']) ? sprintf( __('Project restored to revision from %s', 'satori'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	6 => sprintf( __('Project published. <a href="%s">View project</a>', 'satori'), esc_url( get_permalink($post_ID) ) ),
	7 => __('Project saved.', 'satori'),
	8 => sprintf( __('Project submitted. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	9 => sprintf( __('Project scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview project</a>', 'satori'),
	  // translators: Publish box date format, see http://php.net/date
	  date_i18n( __( 'M j, Y @ G:i' , 'satori'), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	10 => sprintf( __('Project draft updated. <a target="_blank" href="%s">Preview project</a>', 'satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );

  return $messages;
}

function enqueue_filterable()
{
	wp_register_script( 'filterable', get_template_directory_uri() . '/scripts/filterable-portfolio/filterable.js', array( 'jquery' ) );
	wp_enqueue_script( 'filterable' );
}
add_action('wp_enqueue_scripts', 'enqueue_filterable'); 
if ( function_exists( 'add_theme_support' ) )  
{  
add_theme_support(  'post-thumbnails' );
add_image_size( 'portfolio', 500, 300, true ); 
add_image_size( 'expanding', 317, 232, true ); 
}  

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Get URL of first image in a post
function catch_first_image() {
global $post, $posts;
$first_img = '';
ob_start();
ob_end_clean();
$output = preg_match_all('/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches);
$first_img = $matches [1] [0];
return $first_img;
}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Remove Option Tree From User Profile
global $ot_admin;remove_action( 'show_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'edit_user_profile', array( $ot_admin, 'option_tree_extra_profile_fields' ) );remove_action( 'personal_options_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );remove_action( 'edit_user_profile_update', array( $ot_admin, 'option_tree_save_extra_profile_fields' ) );


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Custom exerpt for portfolio items
function new_excerpt_more( $more ) {
if ( is_page_template('page_portfolio-two-column.php') ) {
return '...';
} }
add_filter('excerpt_more', 'new_excerpt_more');

function custom_excerpt_length( $length ) {
if ( is_page_template('page_portfolio-two-column.php') or is_page_template('page_portfolio-one-column.php') or is_page_template('page_portfolio-three-column.php') or is_page_template('page_portfolio-four-column.php') ) {
return 40;
} }
add_filter( 'excerpt_length', 'custom_excerpt_length', 999 );
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Custom search form
function fuji_search_form( $form ) {
$form = '<form role="search" method="get" id="searchform" action="' . home_url( '/' ) . '" >
<div><input type="text" value="'.__('Find..', 'satori').'" name="s" id="s" />
<input type="submit" id="searchsubmit" value="" />
</div>
</form>';
return $form;
}
add_filter( 'get_search_form', 'fuji_search_form' );
////////////////////////////////////////////////////////////////////////////////////////////////////


// Add meta box to pages with header choice options 
$prefix = 'fuji_';
$meta_box = array(
'id' => 'header-choice',
'title' => 'Custom Header',
'page' => 'page',
'context' => 'normal',
'priority' => 'high',
'fields' => array(
	array(
		'name' => 'Choose the header for this page',
		'id' => $prefix . 'header',
		'type' => 'select',
		'options' => array('','No header','Static image','Image slider','Background slider','Expanding slider','Recent posts slider','Google map','Custom HTML')
	)
)
);

add_action('admin_menu', 'mytheme_add_box');
// Add meta box
function mytheme_add_box() {
global $meta_box;
add_meta_box($meta_box['id'], $meta_box['title'], 'mytheme_show_box', $meta_box['page'], $meta_box['context'], $meta_box['priority']);
}

// Callback function to show fields in meta box
function mytheme_show_box() {
global $meta_box, $post;
// Use nonce for verification
echo '<input type="hidden" name="mytheme_meta_box_nonce" value="', wp_create_nonce(basename(__FILE__)), '" />';
echo '<table class="form-table">';
foreach ($meta_box['fields'] as $field) {
	// get current post meta data
	$meta = get_post_meta($post->ID, $field['id'], true);
	echo '<tr>',
			'<th style="width:30%"><label for="', $field['id'], '">', $field['name'], '</label></th>',
			'<td>';
	switch ($field['type']) {
		case 'text':
			echo '<input type="text" name="', $field['id'], '" id="', $field['id'], '" value="', $meta ? $meta : $field['std'], '" size="30" style="width:97%" />', '<br />', $field['desc'];
			break;
		case 'textarea':
			echo '<textarea name="', $field['id'], '" id="', $field['id'], '" cols="60" rows="4" style="width:97%">', $meta ? $meta : $field['std'], '</textarea>', '<br />', $field['desc'];
			break;
		case 'select':
			echo '<select name="', $field['id'], '" id="', $field['id'], '" width="80%">';
			foreach ($field['options'] as $option) {
				echo '<option ', $meta == $option ? ' selected="selected"' : '', '>', $option, '</option>';
			}
			echo '</select>';
			break;
		case 'radio':
			foreach ($field['options'] as $option) {
				echo '<input type="radio" name="', $field['id'], '" value="', $option['value'], '"', $meta == $option['value'] ? ' checked="checked"' : '', ' />', $option['name'];
			}
			break;
		case 'checkbox':
			echo '<input type="checkbox" name="', $field['id'], '" id="', $field['id'], '"', $meta ? ' checked="checked"' : '', ' />';
			break;
	}
	echo     '</td><td>',
		'</td></tr>';
}
echo '</table>';
}

add_action('save_post', 'mytheme_save_data');
// Save data from meta box
function mytheme_save_data($post_id) {
global $meta_box;
// verify nonce
if (isset($_POST['mytheme_meta_box_nonce'])) { if (!wp_verify_nonce($_POST['mytheme_meta_box_nonce'], basename(__FILE__))) {
	return $post_id;
} }
// check autosave
if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
	return $post_id;
}
// check permissions
if (isset($_POST['post_type'])) { if ('page' == $_POST['post_type']) {
	if (!current_user_can('edit_page', $post_id)) {
		return $post_id;
	}
} elseif (!current_user_can('edit_post', $post_id)) {
	return $post_id;
}
foreach ($meta_box['fields'] as $field) {
	$old = get_post_meta($post_id, $field['id'], true);
	$new = $_POST[$field['id']];
	if ($new && $new != $old) {
		update_post_meta($post_id, $field['id'], $new);
	} elseif ('' == $new && $old) {
		delete_post_meta($post_id, $field['id'], $old);
	}
}
}
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Add specific CSS class for one-column portflio by filter
add_filter('body_class','my_class_names');
function my_class_names($classes) {
	// add class to the $classes array
	if(is_page_template('page_portfolio-one-column-paginated.php') || is_page_template('page_portfolio-one-column-filter.php')) {
	$classes[] = 'page-template-page_portfolio-one-column-php';
	}
	// return the $classes array
	return $classes;
}

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Create expanding slider slides 
add_action('init', 'exp_custom_init');      

function exp_custom_init()  
{  
// The following is all the names
$labelsexp = array(
	'name' => _x('Slides', 'post type general name','satori'),
	'singular_name' => _x('Slide', 'post type singular name','satori'),
	'add_new' => _x('Add New', 'slide','satori'),
	'add_new_item' => __('Add New Slide','satori'),
	'edit_item' => __('Edit Slide','satori'),
	'new_item' => __('New Slide','satori'),
	'view_item' => __('View Slide','satori'),
	'search_items' => __('Search Slides','satori'),
	'not_found' =>  __('No slides found','satori'),
	'not_found_in_trash' => __('No slides found in Trash','satori'),
	'parent_item_colon' => '',
	'menu_name' => 'ExpandingSlider'
);

// Some arguments and in the last line 'supports', we say to WordPress what features are supported on the Project post type
$argsexp = array(
	'labels' => $labelsexp,
	'public' => true,
	'publicly_queryable' => true,
	'show_ui' => true,
	'show_in_menu' => true,
	'query_var' => true,
	'rewrite' => true,
	'capability_type' => 'post',
	'has_archive' => true,
	'hierarchical' => false,
	'menu_position' => null,
	'supports' => array('title','editor','author','thumbnail','excerpt','comments')
);

// We call this function to register the custom post type
register_post_type('exp_slide',$argsexp);

// Initialize Taxonomy Labels
$labelsexp = array(
	'name' => _x( 'Tags', 'taxonomy general name','satori' ),
	'singular_name' => _x( 'Tag', 'taxonomy singular name','satori' ),
	'search_items' =>  __( 'Search Types','satori' ),
	'all_items' => __( 'All Tags','satori' ),
	'parent_item' => __( 'Parent Tag','satori' ),
	'parent_item_colon' => __( 'Parent Tag:','satori' ),
	'edit_item' => __( 'Edit Tags','satori' ),
	'update_item' => __( 'Update Tag' ,'satori'),
	'add_new_item' => __( 'Add New Tag','satori' ),
	'new_item_name' => __( 'New Tag Name','satori' ),
);


}  

add_filter('post_updated_messages', 'exp_updated_messages');

function exp_updated_messages( $messages ) {
  global $post, $post_ID;

  $messages['exp_slide'] = array(
	0 => '', // Unused. Messages start at index 1.
	1 => sprintf( __('Slide updated. <a href="%s">View slide</a>','satori'), esc_url( get_permalink($post_ID) ) ),
	2 => __('Custom field updated.','satori'),
	3 => __('Custom field deleted.','satori'),
	4 => __('Slide updated.','satori'),
	/* translators: %s: date and time of the revision */
	5 => isset($_GET['revision']) ? sprintf( __('Slide restored to revision from %s','satori'), wp_post_revision_title( (int) $_GET['revision'], false ) ) : false,
	6 => sprintf( __('Slide published. <a href="%s">View project</a>','satori'), esc_url( get_permalink($post_ID) ) ),
	7 => __('Project saved.','satori'),
	8 => sprintf( __('Slide submitted. <a target="_blank" href="%s">Preview slide</a>','satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
	9 => sprintf( __('Slide scheduled for: <strong>%1$s</strong>. <a target="_blank" href="%2$s">Preview slide</a>','satori'),
	  // translators: Publish box date format, see http://php.net/date
	  date_i18n( __( 'M j, Y @ G:i','satori' ), strtotime( $post->post_date ) ), esc_url( get_permalink($post_ID) ) ),
	10 => sprintf( __('Slide draft updated. <a target="_blank" href="%s">Preview slide</a>','satori'), esc_url( add_query_arg( 'preview', 'true', get_permalink($post_ID) ) ) ),
  );

  return $messages;
}

?>